<template>
  <a-card
    title=""
    :bordered='false'
  >
    <div class='table-page-search-wrapper'>
      <a-form
        layout='inline'
        @keyup.enter.native='searchQuery'
      >
        <a-row :gutter='24'>
          <a-col
            :xl='6'
            :lg='7'
            :md='8'
            :sm='24'
          >
            <a-form-item label='出库单号'>
              <j-input
                placeholder='请输入出库单号'
                v-model='queryParam.num'
              ></j-input>
            </a-form-item>
          </a-col>
          <!-- <a-col
            :xl='6'
            :lg='7'
            :md='8'
            :sm='24'
          >
            <a-form-item label='状态'>
              <a-input
                placeholder='请选择状态'
                v-model='queryParam.name'
              ></a-input>
            </a-form-item>
          </a-col> -->
          <a-col
            :xl='6'
            :lg='7'
            :md='8'
            :sm='24'
          >
            <span
              style='float: left;overflow: hidden;'
              class='table-page-search-submitButtons'
            >
              <a-button
                type='primary'
                @click='searchQuery'
                icon='search'
              >查询</a-button>
              <a-button
                type='primary'
                @click='searchReset'
                icon='reload'
                style='margin-left: 8px'
              >重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class='table-operator'>
      <a-button
        @click='handleAdd'
        v-has="'sparePartOutbound:add'"
        type='primary'
        icon='plus'
      >新增</a-button>
      <a-button @click='handleSubmit' type='primary' icon='check' v-has="'sparePartOutbound:submitAndCancel'"
                v-if="selectedRowKeys.length > 0  && (selectionRows[0].status ==='0'  || selectionRows[0].status==='3')">
        提交
      </a-button>
      <a-button v-if="selectedRowKeys.length > 0  && selectionRows[0].status==='1'"
                @click='handleRevocation' type='primary' icon='rollback'>撤回
      </a-button>


      <!-- <a-dropdown v-if='selectedRowKeys.length > 0'>
        <a-menu slot='overlay'>
          <a-menu-item
            key='1'
            @click='batchDel'
          >
            <a-icon type='delete' />
            删除
          </a-menu-item>
        </a-menu>
        <a-button style='margin-left: 8px'> 批量操作
          <a-icon type='down' />
        </a-button>
      </a-dropdown> -->
    </div>

    <div>
      <!-- <div
        class='ant-alert ant-alert-info'
        style='margin-bottom: 16px;'
      >
        <i class='anticon anticon-info-circle ant-alert-icon'></i> 已选择 <a style='font-weight: 600'>{{ selectedRowKeys.length }}</a>项
        <a
          style='margin-left: 24px'
          @click='onClearSelected'
        >清空</a>
      </div> -->

      <a-table
        ref='table'
        size='middle'
        bordered
        rowKey='id'
        :scroll="{ x: 'calc(1400px + 50%)', y: 900 }"
        :columns='columns'
        :dataSource='dataSource'
        :pagination='ipagination'
        :rowSelection="{selectedRowKeys: selectedRowKeys, onChange: onSelectChange, type:'radio'}"
        :loading='loading'
        :customRow='clickThenSelect'
        @change='handleTableChange'
      >
        <!-- :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}' -->

        <span
          slot='action'
          slot-scope='text, record'
        >
          <a v-if="record.status === '0' || record.status === '3'" @click='handleEdit(record)' v-has="'sparePartOutbound:edit'">编辑</a>
          <a v-if="record.status === '1'" @click='handleApprove(record)'>审批</a>
                <a-divider
                  v-if="record.status == '0' || record.status == '3' || record.status == '1'"
                  type='vertical'
                />
          <a-dropdown>
            <a class='ant-dropdown-link'>更多 <a-icon type='down' /></a>
            <a-menu slot='overlay'>
              <a-menu-item>
                <a @click='handleDetail(record)'>详情</a>
              </a-menu-item>
              <a-menu-item v-if="record.status == '0'||record.status == '3'" v-has="'sparePartOutbound:delete'">
                <a-popconfirm
                  title='确定删除吗?'
                  @confirm='() => handleDelete(record.id)'
                >
                  <a>删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span>
<!--        <span
          slot='action'
          slot-scope='text, record'
        >
          <a
            v-if="record.status === '0'"
            @click='handleEdit(record)'
          >编辑</a>

          <a-divider
            v-if="record.status === '0'"
            type='vertical'
          />
          <a-popconfirm
            title="确定提交入库单吗?"
            @confirm="() => handleSubmit(record)"
          >
            <a v-if="record.status === '0'">提交</a>
          </a-popconfirm>
          <a-popconfirm
            title="确定通过吗?"
            @confirm="() => handlePass(record)"
          >
            <a v-if="record.status === '1'">通过</a>
          </a-popconfirm>
          <a-divider
            v-if="record.status === '1'"
            type="vertical"
          />
          <a-popconfirm
            title="确定撤回吗?"
            @confirm="() => handleReset(record)"
          >
            <a v-if="record.status === '1'">撤回</a>
          </a-popconfirm>
          <a-divider
            v-if="record.status === '0'"
            type="vertical"
          />
          <a-dropdown v-if="record.status === '0'">
            <a class='ant-dropdown-link'>更多 <a-icon type='down' /></a>
            <a-menu slot='overlay'>
              <a-menu-item>
                <a-popconfirm
                  title='确定删除吗?'
                  @confirm='() => handleDelete(record.id)'
                >
                  <a>删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span>-->

      </a-table>
      <a-tabs
        type="card"
        defaultActiveKey="1"
      >
        <a-tab-pane
          tab='备件出库明细信息'
          key="1"
        >
          <div
            class="table-operator"
            style="margin:-16px"
          >
            <spare-part-outbound-detail :sparePartOutboundId='sparePartOutboundId' />
          </div>
        </a-tab-pane>

      </a-tabs>
    </div>

    <spare-part-outbound-modal
      ref='modalForm'
      @ok='modalFormOk'
    ></spare-part-outbound-modal>
    <approvel-modal ref='approvalModalForm' @ok='approvalModalFormOk' @cancel='approvalModalFormOk'></approvel-modal>
  </a-card>
</template>

<script>

import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import { getAction, requestPut } from '@/api/manage'
import SparePartOutboundDetail from './modules/sparePartOutbound/SparePartOutboundDetail'
import SparePartOutboundModal from './modules/sparePartOutbound/SparePartOutboundModal'
import '@/assets/less/TableExpand.less'
import ApprovelModal from '@views/common/ApprovelModal'
export default {
  name: 'SparePartOutboundList',
  mixins: [JeecgListMixin],
  components: {
    SparePartOutboundDetail,
    SparePartOutboundModal,
    ApprovelModal
  },
  data() {
    return {
      columns: [
        {
          title: '#',
          dataIndex: '',
          key: 'rowIndex',
          width: 60,
          align: 'center',
          customRender: function (t, r, index) {
            return parseInt(index) + 1
          }
        },
        {
          title: '出库单编码',
          align: 'center',
          dataIndex: 'num',
        },
        {
          title: '状态',
          align: 'center',
          dataIndex: 'status_dictText',
        },
        {
          title: '仓库',
          align: 'center',
          dataIndex: 'warehouseId_dictText',
        },
        {
          title: '领用部门',
          align: 'center',
          dataIndex: 'departId_dictText',
        },
        {
          title: '出库人员',
          align: 'center',
          dataIndex: 'outboundPersonId_dictText',
        },
        {
          title: '创建人',
          align: 'center',
          dataIndex: 'createBy',
        },
        {
          title: '创建日期',
          align: 'center',
          dataIndex: 'createTime',
        },
        {
          title: '更新人',
          align: 'center',
          dataIndex: 'updateBy',
        },
        {
          title: '更新日期',
          align: 'center',
          dataIndex: 'updateTime',
        },
        {
          title: '操作',
          dataIndex: 'action',
          align: 'center',
          fixed: 'right',
          scopedSlots: { customRender: 'action' },
          width: 200,
        }
      ],
      url: {
        list: '/spare/sparePartOutbound/list',
        delete: '/spare/sparePartOutbound/delete',
        deleteBatch: '/spare/sparePartOutbound/deleteBatch',
        auditOperation: "/spare/sparePartOutbound/auditOperation",
        /*新增*/
        submit: '/spare/sparePartOutbound/submit',
        revocation: '/spare/sparePartOutbound/revocation',
        reject: 'spare/sparePartOutbound/reject',
        approval: 'spare/sparePartOutbound/approval'
      },
      /* 分页参数 */
      ipagination: {
        current: 1,
        pageSize: 5,
        pageSizeOptions: ['5', '10', '50'],
        showTotal: (total, range) => {
          return range[0] + '-' + range[1] + ' 共' + total + '条'
        },
        showQuickJumper: true,
        showSizeChanger: true,
        total: 0
      },
      sparePartOutboundId: '-1'
    }
  },
  mounted() {
    this.$bus.$on('outboundSuccess', (data) => {
      this.loadData()
    })
  },
  methods: {
    clickThenSelect(record) {
      return {
        on: {
          click: () => {
            this.onSelectChange(record.id.split(','), [record])
          }
        }
      }
    },
    onClearSelected() {
      this.selectedRowKeys = []
      this.selectionRows = []
      this.sparePartOutboundId = '-1'
    },
    onSelectChange(selectedRowKeys, selectionRows) {
      if (selectedRowKeys.length == 1) {
        this.sparePartOutboundId = selectionRows[0]['id']
      } else {
        this.sparePartOutboundId = '-1'
      }
      this.selectedRowKeys = selectedRowKeys
      this.selectionRows = selectionRows
    },
    handleApprove: function(record) {
      let reject, approval
      reject = this.url.reject
      approval = this.url.approval
      this.$refs.approvalModalForm.showModals(record, reject, approval)
      this.$refs.approvalModalForm.title = '审批'
      this.$refs.approvalModalForm.disableSubmit = false

    },
    approvalModalFormOk() {
      // 通过/驳回时，重载列表
      this.loadData()
      //清空列表选中
      this.onClearSelected()
    },
/*    handleSubmit(record) {
      const that = this;
      requestPut(that.url.auditOperation, { id: record.id, status: '1' }).then((res) => {
        if (res.success) {
          that.$message.success("提交成功!")
          that.loadData()
        } else {
          that.$message.warning("提交失败!")
        }
      })
    },*/
    handlePass(record) {
      const that = this;
      requestPut(that.url.auditOperation, { id: record.id, status: '2' }).then((res) => {
        if (res.success) {
          that.$message.success("审核通过!")
          that.loadData()
        } else {
          that.$message.warning("审核失败!")
        }
      })
    },
    handleReset(record) {
      const that = this;
      requestPut(that.url.auditOperation, { id: record.id, status: '0' }).then((res) => {
        if (res.success) {
          that.$message.success("撤回成功!")
          that.loadData()
        } else {
          that.$message.warning("撤回失败!")
        }
      })
    },
    loadData(arg) {
      if (!this.url.list) {
        this.$message.error('请设置url.list属性!')
        return
      }
      //加载数据 若传入参数1则加载第一页的内容
      if (arg === 1) {
        this.ipagination.current = 1
      }
      this.onClearSelected()
      var params = this.getQueryParams()//查询条件
      this.loading = true
      getAction(this.url.list, params).then((res) => {
        if (res.success) {
          this.dataSource = res.result.records
          this.ipagination.total = res.result.total
        }
        if (res.code === 510) {
          this.$message.warning(res.message)
        }
        this.loading = false
      })
    },
    searchReset() {
      this.sparePartOutboundId = '-1'
      this.queryParam = {}
      this.loadData(1);
    },
  }

}
</script>
<style scoped>
@import '~@assets/less/common.less';
.table-operator .ant-btn {
  margin: 10px 8px 8px 10px;
}
</style>